<?php
class SWIFT_SetupDatabase_customtweaks extends SWIFT_SetupDatabase
{
    public function __construct()
	{
		parent::__construct("customtweaks");
		return true;
	}

	public function __destruct()
	{
		parent::__destruct("customtweaks");
		return true;
	}

	public function Install($_pageIndex)
	{
		parent::Install($_pageIndex);

$_CurrentVersion = substr(SWIFT_VERSION, 0,4);

If ($_CurrentVersion == '4.65'){
$_UpdatePath = '/../library/files/4.65/';
}
elseif ($_CurrentVersion == '4.66'){
$_UpdatePath = '/../library/files/4.66/';
}
elseif ($_CurrentVersion == '4.67'){
$_UpdatePath = '/../library/files/4.67/';
}
elseif ($_CurrentVersion == '4.68'){
$_UpdatePath = '/../library/files/4.68/';
}
elseif ($_CurrentVersion == '4.69'){
$_UpdatePath = '/../library/files/4.69/';
}
elseif ($_CurrentVersion == '4.70'){
$_UpdatePath = '/../library/files/4.70/';
}
elseif ($_CurrentVersion == '4.71'){
$_UpdatePath = '/../library/files/4.71/';
}
elseif ($_CurrentVersion == '4.72'){
$_UpdatePath = '/../library/files/4.72/';
}
else{
     echo 'This version of custom tweaks only supports Kayako 4.65 - 4.72. Your current version of Kayako is:' . $_CurrentVersion;
     return false;
}

    //$_SWIFT = SWIFT::GetInstance();
//echo 'Language Selected' . $_SWIFT->Language->GetLanguageCode();

// COPY outbound rich HTML fix

if (file_exists(__DIR__ . '/../../../__swift/cache/SWIFT_Loader.cache')) {
    unlink(__DIR__ . '/../../../__swift/cache/SWIFT_Loader.cache');
}



// COPY FIX for old macros after installing CT

if ( !rename(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.php',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 44 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Macro.phpct',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 45 )';
      return false;
}
}




// COPY API TURN OFF EMAIL WHEN USING API

if ( !rename(__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.php',__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 40 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_TicketPost.phpct',__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 41 )';
      return false;
}
}



if ( !rename(__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.php',__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 7 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_TicketPost.phpct',__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 8 )';
      return false;
}
}

// COPY CLIENT Missing content fixes


if ( !rename(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.php',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 44 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Submit.phpct',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 45 )';
      return false;
}
}

if ( !rename(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.php',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 46 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Ticket.phpctclient',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 47 )';
      return false;
}
}





// COPY CLIENT TINY MCE FIXES


if ( !rename(__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.js',__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.jsold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 23 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'core.jsct',__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.js')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 24 )';
      return false;
}
}


// COPY TROUBLE SHOOTER STEP PROCESSOR


if ( !rename(__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.php',__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 20 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Step.phpct',__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 21 )';
      return false;
}
}

// COPY BEAUTIFUL HTML FIX


if ( !rename(__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.php',__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 22 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'BeautifulHTMLTicketPosts.phpct',__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 23 )';
      return false;
}
}




// COPY USER INTERFACE HOOK ( Spell Checker )


if ( !rename(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.php',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 1 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_UserInterfaceToolbar.phpct',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 2 )';
      return false;
}
}

// COPY USER INTERFACE HOOK ( Macros Hook )


if ( !rename(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.php',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 1 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_UserInterfaceControlPanel.phpct',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 2 )';
      return false;
}
}



// FIX OUTBOUND HTML MISSING LAST LINE WITHOUT TIDY


if ( !rename(__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.php',__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 20 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_TicketEmailDispatch.phpct',__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 21 )';
      return false;
}
}


// COPY JAVA SCRIPT UPDATED FILE
//got here on 4.72 checking
if ( !rename(__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.js',__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.jsold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 1 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'staff.jsct',__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.js')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 2 )';
      return false;
}
}


// COPY ENABLE HTML FILE
if ( !rename(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.php',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 3 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Ticket.phpct',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 4 )';
      return false;
}
}

// COPY ENABLE Editor in Edit Replies
if ( !rename(__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.php',__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 7 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.View_Ticket.phpct',__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 8 )';
      return false;
}
}


// COPY REMOVE EVIL ATTRIBUTES FILE
if ( !rename(__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.php',__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 5 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_Input.phpct',__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 6 )';
      return false;
}
}

// COPY Macro Setup file
if ( !rename(__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.php',__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 9 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.View_MacroReply.phpct',__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 10 )';
      return false;
}
}





// Alter Footer Template to add the new WYSIWYG Editor
        $_AddTinyMCE = '<!--CUSTOMWYSIWYG-->
        <script type="text/javascript" src="<{$_settings[general_producturl]}>__apps/customtweaks/library/tinymce/tinymce.min.js"></script>
        <script>
tinyMCE.baseURL = "<{$_settings[general_producturl]}>__apps/customtweaks/library/tinymce/";
</script>

<script type="text/javascript">
tinymce.init({
            mode : "specific_textareas",
        editor_selector : "swifttextareawide",
paste_data_images: true,
    forced_root_block : false,
    force_p_newlines : false,
    remove_linebreaks : false,
    browser_spellcheck : true,
    entity_encoding : "raw",
    relative_urls : false,
remove_script_host : false,
convert_urls : true,
    gecko_spellcheck: true,
    <{if $_languageContainer[$_activeLanguageID][languagecode] != "en-us"}>language:"<{$_languageContainer[$_activeLanguageID][languagecode]}>",<{/if}>
    force_br_newlines : true,              //btw, I still get <p> tags if this is false
    remove_trailing_nbsp : false,
    content_css : "<{$_settings[general_producturl]}>__apps/customtweaks/library/tinymce/themes/content.css",
    verify_html : false,
    theme: "modern",
    plugins: [
        "advlist autolink lists link image charmap print preview hr anchor pagebreak",
        "searchreplace wordcount visualblocks visualchars code fullscreen",
        "insertdatetime media nonbreaking save table directionality",
        "emoticons template paste textcolor"
    ],
    toolbar1: "insertfile undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image",
    toolbar2: "print preview media | forecolor backcolor emoticons",
    image_advtab: true,

});
</script><!--ENDCUSTOMWYSIWYG-->
';

$this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'footer'");

while ($this->Database->NextRecord())
{

    $_TemplateIDtoAlter[] = $this->Database->Record['templateid'];


}

foreach($_TemplateIDtoAlter as $TemplateID){
    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $TemplateID );
    while ($this->Database->NextRecord())
    {

        $_StartContents = $this->Database->Record['contents'];
 $_LocationToAdd = strrpos($this->Database->Record['contents'],"</body>");
 $newstring = substr_replace($_StartContents, $_AddTinyMCE, $_LocationToAdd, 0);
$this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($newstring) . "' where templateid = " . $TemplateID );
    }
    }


// Remove "message conetents" from submit ticket confirmation, as it will not render very pretty

$this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'submitticket_confirmation'");

while ($this->Database->NextRecord())
{

    $_TemplateIDtoAlter = $this->Database->Record['templateid'];

    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $_TemplateIDtoAlter );
    while ($this->Database->NextRecord())
    {

        $_StartContents = $this->Database->Record['contents'];
 $_LocationToAdd = strrpos($this->Database->Record['contents'],"</body>");
 $newstring = self::delete_all_between('<{$_ticketMessage}>', '<{$_ticketMessage}>', $_StartContents);
$this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($newstring) . "' where templateid = " . $_TemplateIDtoAlter );
    }

}


// Update client CSS to remove dodgy css elements
$this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'clientcss'");

while ($this->Database->NextRecord())
{
$_TemplateIDtoAlter = $this->Database->Record['templateid'];
    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $_TemplateIDtoAlter );
    while ($this->Database->NextRecord())
    {

        $_StartContents = $this->Database->Record['contents'];

    $_StartContents = str_replace("html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video", "html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,fieldset,form,label,legend,caption,thead,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video", $_StartContents);
    $_StartContents = str_replace("body, div, dl, dt, dd, ul, ol, li, h1, h2, h3, h4, h5, h6, pre, form, p, blockquote, th, td", "body, div, dl, dt, dd, h1, h2, h3, h4, h5, h6, pre, form, p, blockquote", $_StartContents);
    $_StartContents = str_replace("list-style: none;", "", "$_StartContents");

    $pos = strpos($_StartContents, "/* CT Update */");

if ($pos === false) {
    $_StartContents = $_StartContents . "
    /* CT Update */
    .ticketpostcontentsdetailscontainer{
overflow : auto;
}";
}

    $this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($_StartContents) . "' where templateid = " . $_TemplateIDtoAlter );
    }




}



SWIFT_CacheManager::EmptyCacheDirectory();
SWIFT_CacheManager::RebuildEntireCache();

		return true;
	}

	public function Uninstall()
	{
		parent::Uninstall("customtweaks");

// put back origional files

if (file_exists(__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.php');
    rename(__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.phpold',__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 141 )";
}


if (file_exists(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.php');
    rename(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.phpold',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 110 )";
}




if (file_exists(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.php');
    rename(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.phpold',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.php');
    rename(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.phpold',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.php');
    rename(__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.phpold',__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}

if (file_exists(__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.jsold')) {
    unlink(__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.js');
    rename(__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.jsold',__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.js');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 120 )";
}

if (file_exists(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.phpold')) {
    unlink(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.php');
    rename(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.phpold',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 102 )";
}

if (file_exists(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.phpold')) {
    unlink(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.php');
    rename(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.phpold',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 102 )";
}

if (file_exists(__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.jsold')) {
    unlink(__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.js');
    rename(__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.jsold',__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.js');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}

if (file_exists(__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.phpold')) {
    unlink(__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.php');
    rename(__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.phpold',__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 102 )";
}


if (file_exists(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.php');
    rename(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.phpold',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 103 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.php');
    rename(__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.phpold',__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 104 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.php');
    rename(__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.phpold',__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 105 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.php');
    rename(__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.phpold',__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 106 )";
}

if (file_exists(__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.phpold')) {
    unlink(__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.php');
    rename(__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.phpold',__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 107 )";
}


if (file_exists(__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.phpold')) {
    unlink(__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.php');
    rename(__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.phpold',__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}





if (file_exists(__DIR__ . '/../../../__swift/cache/SWIFT_Loader.cache')) {
    unlink(__DIR__ . '/../../../__swift/cache/SWIFT_Loader.cache');
}



        $this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'footer'");

while ($this->Database->NextRecord())
{

    $_TemplateIDtoAlter[] = $this->Database->Record['templateid'];

}
foreach($_TemplateIDtoAlter as $TemplateID){
    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $TemplateID );
    while ($this->Database->NextRecord())
    {
        $_StartContents = $this->Database->Record['contents'];

$newstring = self::delete_all_between('<!--CUSTOMWYSIWYG-->', '<!--ENDCUSTOMWYSIWYG-->', $_StartContents);

$this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($newstring) . "' where templateid = " . $TemplateID );
    }

}

// <td align="left" valign="top"></td>

// put back missing template hack

$this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'submitticket_confirmation'");

while ($this->Database->NextRecord())
{

    $_TemplateIDtoAlter = $this->Database->Record['templateid'];

    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $_TemplateIDtoAlter );
    while ($this->Database->NextRecord())
    {
     $_AddTinyMCE = '<{$_ticketMessage}>';
     $_StartContents = $this->Database->Record['contents'];
 $_LocationToAdd = strrpos($this->Database->Record['contents'],'<td align="left" valign="top"></td>');
 $newstring = substr_replace($_StartContents, $_AddTinyMCE, $_LocationToAdd + 30, 0);
$this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($newstring) . "' where templateid = " . $_TemplateIDtoAlter );
    }

}

SWIFT_CacheManager::EmptyCacheDirectory();
SWIFT_CacheManager::RebuildEntireCache();


		return true;
	}

    public function delete_all_between($beginning, $end, $string) {
  $beginningPos = strpos($string, $beginning);
  $endPos = strpos($string, $end);
  if (!$beginningPos || !$endPos) {
    return $string;
  }

  $textToDelete = substr($string, $beginningPos, ($endPos + strlen($end)) - $beginningPos);

  return str_replace($textToDelete, '', $string);
}


	public function Upgrade($_isForced = false)
	{

// REMOVE OLD VERSIONS


// put back origional files

if (file_exists(__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.php');
    rename(__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.phpold',__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.php');
    rename(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.phpold',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 110 )";
}



if (file_exists(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.php');
    rename(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.phpold',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.php');
    rename(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.phpold',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.php');
    rename(__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.phpold',__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}

if (file_exists(__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.jsold')) {
    unlink(__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.js');
    rename(__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.jsold',__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.js');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 120 )";
}

if (file_exists(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.phpold')) {
    unlink(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.php');
    rename(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.phpold',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 102 )";
}

if (file_exists(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.phpold')) {
    unlink(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.php');
    rename(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.phpold',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 102 )";
}

if (file_exists(__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.jsold')) {
    unlink(__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.js');
    rename(__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.jsold',__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.js');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}

if (file_exists(__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.phpold')) {
    unlink(__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.php');
    rename(__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.phpold',__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 102 )";
}


if (file_exists(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.php');
    rename(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.phpold',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 103 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.php');
    rename(__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.phpold',__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 104 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.php');
    rename(__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.phpold',__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 105 )";
}

if (file_exists(__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.phpold')) {
    unlink(__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.php');
    rename(__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.phpold',__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 106 )";
}

if (file_exists(__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.phpold')) {
    unlink(__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.php');
    rename(__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.phpold',__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 107 )";
}

if (file_exists(__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.phpold')) {
    unlink(__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.php');
    rename(__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.phpold',__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.php');
} else {
    echo "Could not put back origional files, they must have been removed? ( error 101 )";
}



if (file_exists(__DIR__ . '/../../../__swift/cache/SWIFT_Loader.cache')) {
    unlink(__DIR__ . '/../../../__swift/cache/SWIFT_Loader.cache');
}



        $this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'footer'");

while ($this->Database->NextRecord())
{

    $_TemplateIDtoAlter[] = $this->Database->Record['templateid'];

}
foreach($_TemplateIDtoAlter as $TemplateID){
    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $TemplateID );
    while ($this->Database->NextRecord())
    {
        $_StartContents = $this->Database->Record['contents'];

$newstring = self::delete_all_between('<!--CUSTOMWYSIWYG-->', '<!--ENDCUSTOMWYSIWYG-->', $_StartContents);

$this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($newstring) . "' where templateid = " . $TemplateID );
    }

}

// <td align="left" valign="top"></td>

// put back missing template hack

$this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'submitticket_confirmation'");

while ($this->Database->NextRecord())
{

    $_TemplateIDtoAlter = $this->Database->Record['templateid'];

    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $_TemplateIDtoAlter );
    while ($this->Database->NextRecord())
    {
     $_AddTinyMCE = '<{$_ticketMessage}>';
     $_StartContents = $this->Database->Record['contents'];
 $_LocationToAdd = strrpos($this->Database->Record['contents'],'<td align="left" valign="top"></td>');
 $newstring = substr_replace($_StartContents, $_AddTinyMCE, $_LocationToAdd + 30, 0);
$this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($newstring) . "' where templateid = " . $_TemplateIDtoAlter );
    }

}

// Update client CSS to remove dodgy css elements
$this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'clientcss'");

while ($this->Database->NextRecord())
{
$_TemplateIDtoAlter = $this->Database->Record['templateid'];
    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $_TemplateIDtoAlter );
    while ($this->Database->NextRecord())
    {

        $_StartContents = $this->Database->Record['contents'];

    $_StartContents = str_replace("html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video", "html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,fieldset,form,label,legend,caption,thead,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video", $_StartContents);
    $_StartContents = str_replace("body, div, dl, dt, dd, ul, ol, li, h1, h2, h3, h4, h5, h6, pre, form, p, blockquote, th, td", "body, div, dl, dt, dd, h1, h2, h3, h4, h5, h6, pre, form, p, blockquote", $_StartContents);
    $_StartContents = str_replace("list-style: none;", "", "$_StartContents");

    $pos = strpos($_StartContents, "/* CT Update */");

if ($pos === false) {
    $_StartContents = $_StartContents . "
    /* CT Update */
    .ticketpostcontentsdetailscontainer{
overflow : auto;
}";
}

    $this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($_StartContents) . "' where templateid = " . $_TemplateIDtoAlter );
    }




}

SWIFT_CacheManager::EmptyCacheDirectory();
SWIFT_CacheManager::RebuildEntireCache();


// now lets reinstall it all


$_CurrentVersion = substr(SWIFT_VERSION, 0,4);

If ($_CurrentVersion == '4.65'){
$_UpdatePath = '/../library/files/4.65/';
}
elseif ($_CurrentVersion == '4.66'){
$_UpdatePath = '/../library/files/4.66/';
}
elseif ($_CurrentVersion == '4.67'){
$_UpdatePath = '/../library/files/4.67/';
}
elseif ($_CurrentVersion == '4.68'){
$_UpdatePath = '/../library/files/4.68/';
}
elseif ($_CurrentVersion == '4.69'){
$_UpdatePath = '/../library/files/4.69/';
}
else{
     echo 'This version of custom tweaks only supports Kayako 4.65 - 4.68. Your current version of Kayako is:' . $_CurrentVersion;
     return false;
}

    //$_SWIFT = SWIFT::GetInstance();
//echo 'Language Selected' . $_SWIFT->Language->GetLanguageCode();

// COPY FIX for old macros after installing CT

if ( !rename(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.php',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 44 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Macro.phpct',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Macro.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 45 )';
      return false;
}
}


// COPY API TURN OFF EMAIL WHEN USING API

if ( !rename(__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.php',__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 40 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_TicketPost.phpct',__DIR__ . '/../../../__apps/tickets/api/class.Controller_TicketPost.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 41 )';
      return false;
}
}


// COPY outbound rich HTML fix

if (file_exists(__DIR__ . '/../../../__swift/cache/SWIFT_Loader.cache')) {
    unlink(__DIR__ . '/../../../__swift/cache/SWIFT_Loader.cache');
}

if ( !rename(__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.php',__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 7 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_TicketPost.phpct',__DIR__ . '/../../../__apps/tickets/models/Ticket/class.SWIFT_TicketPost.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 8 )';
      return false;
}
}

// COPY CLIENT Missing content fixes


if ( !rename(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.php',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 44 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Submit.phpct',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Submit.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 45 )';
      return false;
}
}

if ( !rename(__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.php',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 46 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Ticket.phpctclient',__DIR__ . '/../../../__apps/tickets/client/class.Controller_Ticket.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 47 )';
      return false;
}
}


// COPY CLIENT TINY MCE FIXES


if ( !rename(__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.js',__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.jsold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 23 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'core.jsct',__DIR__ . '/../../../__swift/apps/base/javascript/client/thirdparty/legacy/core.js')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 24 )';
      return false;
}
}

// COPY TROUBLE SHOOTER STEP PROCESSOR


if ( !rename(__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.php',__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 20 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Step.phpct',__DIR__ . '/../../../__apps/troubleshooter/client/class.Controller_Step.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 21 )';
      return false;
}
}

// COPY BEAUTIFUL HTML FIX


if ( !rename(__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.php',__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 22 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'BeautifulHTMLTicketPosts.phpct',__DIR__ . '/../../../__swift/thirdparty/BeautifulHTMLTicketPosts/BeautifulHTMLTicketPosts.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 23 )';
      return false;
}
}

// COPY USER INTERFACE HOOK ( Spell Checker )


if ( !rename(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.php',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 1 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_UserInterfaceToolbar.phpct',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceToolbar.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 2 )';
      return false;
}
}

// COPY USER INTERFACE HOOK ( Macros Hook )


if ( !rename(__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.php',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 1 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_UserInterfaceControlPanel.phpct',__DIR__ . '/../../../__swift/apps/base/library/UserInterface/class.SWIFT_UserInterfaceControlPanel.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 2 )';
      return false;
}
}



// FIX OUTBOUND HTML MISSING LAST LINE WITHOUT TIDY


if ( !rename(__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.php',__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 20 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_TicketEmailDispatch.phpct',__DIR__ . '/../../../__apps/tickets/library/Ticket/class.SWIFT_TicketEmailDispatch.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 21 )';
      return false;
}
}


// COPY JAVA SCRIPT UPDATED FILE

if ( !rename(__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.js',__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.jsold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 1 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'staff.jsct',__DIR__ . '/../../../__swift/apps/base/javascript/staff/thirdparty/legacy/staff.js')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 2 )';
      return false;
}
}


// COPY ENABLE HTML FILE
if ( !rename(__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.php',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 3 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.Controller_Ticket.phpct',__DIR__ . '/../../../__apps/tickets/staff/class.Controller_Ticket.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 4 )';
      return false;
}
}

// COPY ENABLE Editor in Edit Replies
if ( !rename(__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.php',__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 7 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.View_Ticket.phpct',__DIR__ . '/../../../__apps/tickets/staff/class.View_Ticket.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 8 )';
      return false;
}
}


// COPY REMOVE EVIL ATTRIBUTES FILE
if ( !rename(__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.php',__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 5 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.SWIFT_Input.phpct',__DIR__ . '/../../../__swift/library/Input/class.SWIFT_Input.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 6 )';
      return false;
}
}

// COPY Macro Setup file
if ( !rename(__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.php',__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.phpold')){
  echo 'Error applying automated fixes, likely folder permission restrictions ( Error 9 )';
  return false;
}else{
if ( !copy(__DIR__ . $_UpdatePath . 'class.View_MacroReply.phpct',__DIR__ . '/../../../__apps/tickets/staff/class.View_MacroReply.php')){
      echo 'Error applying automated fixes, likely folder permission restrictions ( Error 10 )';
      return false;
}
}

// Alter Footer Template to add the new WYSIWYG Editor
        $_AddTinyMCE = '<!--CUSTOMWYSIWYG-->
        <script type="text/javascript" src="<{$_settings[general_producturl]}>__apps/customtweaks/library/tinymce/tinymce.min.js"></script>
        <script>
tinyMCE.baseURL = "<{$_settings[general_producturl]}>__apps/customtweaks/library/tinymce/";
</script>

<script type="text/javascript">
tinymce.init({
            mode : "specific_textareas",
        editor_selector : "swifttextareawide",
paste_data_images: true,
    forced_root_block : false,
    force_p_newlines : false,
    remove_linebreaks : false,
    browser_spellcheck : true,
    entity_encoding : "raw",
    relative_urls : false,
remove_script_host : false,
convert_urls : true,
    gecko_spellcheck: true,
    <{if $_languageContainer[$_activeLanguageID][languagecode] != "en-us"}>language:"<{$_languageContainer[$_activeLanguageID][languagecode]}>",<{/if}>
    force_br_newlines : true,              //btw, I still get <p> tags if this is false
    remove_trailing_nbsp : false,
    content_css : "<{$_settings[general_producturl]}>__apps/customtweaks/library/tinymce/themes/content.css",
    verify_html : false,
    theme: "modern",
    plugins: [
        "advlist autolink lists link image charmap print preview hr anchor pagebreak",
        "searchreplace wordcount visualblocks visualchars code fullscreen",
        "insertdatetime media nonbreaking save table directionality",
        "emoticons template paste textcolor"
    ],
    toolbar1: "insertfile undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image",
    toolbar2: "print preview media | forecolor backcolor emoticons",
    image_advtab: true,

});
</script><!--ENDCUSTOMWYSIWYG-->
';

$this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'footer'");
unset($_TemplateIDtoAlter);
while ($this->Database->NextRecord())
{

    $_TemplateIDtoAlter[] = $this->Database->Record['templateid'];


}

foreach($_TemplateIDtoAlter as $TemplateID){
    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $TemplateID );
    while ($this->Database->NextRecord())
    {

        $_StartContents = $this->Database->Record['contents'];
 $_LocationToAdd = strrpos($this->Database->Record['contents'],"</body>");
 $newstring = substr_replace($_StartContents, $_AddTinyMCE, $_LocationToAdd, 0);
$this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($newstring) . "' where templateid = " . $TemplateID );
    }
    }


// Remove "message conetents" from submit ticket confirmation, as it will not render very pretty

$this->Database->Query("select templateid from " . TABLE_PREFIX . "templates where name = 'submitticket_confirmation'");

while ($this->Database->NextRecord())
{

    $_TemplateIDtoAlter = $this->Database->Record['templateid'];

    $this->Database->Query("select contents from " . TABLE_PREFIX . "templatedata where templateid = " . $_TemplateIDtoAlter );
    while ($this->Database->NextRecord())
    {

        $_StartContents = $this->Database->Record['contents'];
 $_LocationToAdd = strrpos($this->Database->Record['contents'],"</body>");
 $newstring = self::delete_all_between('<{$_ticketMessage}>', '<{$_ticketMessage}>', $_StartContents);
$this->Database->Execute("update " . TABLE_PREFIX . "templatedata SET contents = '" . addslashes($newstring) . "' where templateid = " . $_TemplateIDtoAlter );
    }

}


SWIFT_CacheManager::EmptyCacheDirectory();
SWIFT_CacheManager::RebuildEntireCache();

			$this->Settings->UpdateKey('installedapps', 'customtweaks', '1', true);
			$this->Settings->UpdateKey('appversions', 'customtweaks', '2.9.8', true);

        return true;

	}
}
?>